import React, { RefObject } from "react";

export interface ButtonProps {
  size?: "small" | "large";
  variant?: "redpink" | "white";
  tel?: boolean;
  dot?: boolean;
}

declare const Button: React.FunctionComponent<ButtonProps>;

export interface NavTabProps {
  title: string;
  active?: boolean;
  variant?: "black" | "white";
}

declare const NavTab: React.FunctionComponent<NavTabProps>;

declare const NavTabItem: StyledComponent<
  "li",
  any,
  {
    active: boolean;
  },
  never
>;

export interface TitleProps {
  text: Array<string>;
  caption?: string;
  exclusive?: boolean;
  space?: number;
}

declare const Title: React.FunctionComponent<TitleProps>;

export interface PhotoCardProps {
  src: string;
  deco?: "type1" | "type2" | "type3";
  width?: number;
  exclusive?: boolean;
}

declare const PhotoCard: React.FunctionComponent<PhotoCardProps>;

export interface MiniCardProps {
  title: string;
  subTitle: string;
  image: string;
  space: number;
}

declare const MiniCard: React.FunctionComponent<MiniCardProps>;

export interface TitleToggleSwitchProps {
  toggle: boolean;
  handleToggle: () => void;
  title: [string, string];
}

declare const TitleToggleSwitch: React.FunctionComponent<TitleToggleSwitchProps>;

export interface IconListProps {
  data: Array<{
    icon: string;
    title: Array<string>;
    description: string;
  }>;
}

declare const IconList: React.FunctionComponent<IconListProps>;

declare const TextCard: StyledComponent<"div", any, {}, never>;

export interface ArrowLinkProps {
  variant: "white" | "redpink";
  direction: "east" | "north-east";
  link: string;
  children?: string;
}

declare const ArrowLink: React.FunctionComponent<ArrowLinkProps>;

export interface NavigationProps {
  variant: "white" | "transparent";
}

declare const Navigation: React.FunctionComponent<NavigationProps>;

export interface CounterProps {
  num: number;
  title?: string;
  fixed?: string;
}

declare const Counter: React.FunctionComponent<CounterProps>;

export interface SectionProps {}

declare const Section: StyledComponent<"section", any, SectionProps, never>;

export interface ArticleProps {
  center?: boolean;
  reverse?: boolean;
  breakPoint?: "mobile" | "tablet";
}

declare const Article: StyledComponent<"article", any, ArticleProps, never>;

export interface NavSlideProps {
  show: boolean;
  onClose: () => void;
}

declare const NavSlide: React.FunctionComponent<NavSlideProps>;

export interface NavSlideButtonProps {
  variant: "white" | "black";
}

declare const NavSlideButton: StyledComponent<
  "button",
  any,
  NavSlideButtonProps,
  never
>;

export interface ModalProps {
  show: boolean;
  onClose: () => void;
  closeButton?: boolean;
}

declare const Modal: React.FunctionComponent<ModalProps>;

export interface GlobalStyleProps {}

declare const GlobalStyle: GlobalStyleComponent<GlobalStyleProps, DefaultTheme>;

declare const useScrollLocation: () => number;

declare const useCounterAnimation: (
  number: number,
  currentLocation: number,
  counter: RefObject<any>
) => number;
